commit 57f6800aefdd102cd43f0df53ca8bcbcc7202b41
Author: Richard Biener <rguenther@suse.de>
Date:   Wed Aug 25 10:06:01 2021

    tree-optimization/102046 - fix SLP build from scalars with patterns
    
    When we swap operands for SLP builds we lose track where exactly
    pattern defs are - but we fail to update the any_pattern member
    of the operands info.  Do so conservatively.
    
    2021-08-25  Richard Biener  <rguenther@suse.de>
    
            PR tree-optimization/102046
            * tree-vect-slp.c (vect_build_slp_tree_2): Conservatively
            update ->any_pattern when swapping operands.
    
            * gcc.dg/vect/pr102046.c: New testcase.
    
    (cherry picked from commit 29c77454e5ab33ce06a741eacdfbd5348fbccc95)

diff --git a/gcc/testsuite/gcc.dg/vect/pr102046.c b/gcc/testsuite/gcc.dg/vect/pr102046.c
new file mode 100644
index 00000000000..ae48b497dc0
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/vect/pr102046.c
@@ -0,0 +1,19 @@
+/* { dg-do compile } */
+/* { dg-additional-options "-O3 -fvect-cost-model=dynamic" } */
+/* { dg-additional-options "-march=btver2" { target x86_64-*-* i?86-*-* } } */
+
+struct S
+{
+  unsigned a, b;
+};
+
+struct S g;
+
+void
+foo (struct S *o)
+{
+  struct S s = g;
+  s.b *= 3;
+  s.a -= s.a / 2;
+  *o = s;
+}
diff --git a/gcc/tree-vect-slp.c b/gcc/tree-vect-slp.c
index ffecc9a7cd3..bae255e96d5 100644
--- a/gcc/tree-vect-slp.c
+++ b/gcc/tree-vect-slp.c
@@ -1819,6 +1819,10 @@ vect_build_slp_tree_2 (vec_info *vinfo, slp_tree node,
 	      }
 	  if (dump_enabled_p ())
 	    dump_printf (MSG_NOTE, "\n");
+	  /* After swapping some operands we lost track whether an
+	     operand has any pattern defs so be conservative here.  */
+	  if (oprnds_info[0]->any_pattern || oprnds_info[1]->any_pattern)
+	    oprnds_info[0]->any_pattern = oprnds_info[1]->any_pattern = true;
 	  /* And try again with scratch 'matches' ... */
 	  bool *tem = XALLOCAVEC (bool, group_size);
 	  if ((child = vect_build_slp_tree (vinfo, oprnd_info->def_stmts,

